
.macro start_isr
                push    r16
                in      r16, SREG
                push    r16
.endm

.macro end_isr
                pop     r16
                out     SREG, r16
                pop     r16
                reti
.endm

.macro ldpgmad
  .message "no parameters specified"
.endm

.macro ldpgmad_i
                ldi     ZL, LOW(@0 * 2)
                ldi     ZH, HIGH(@0 * 2)
.endm



.macro ld16
  .message "no parameters specified"
.endm

.macro ld16_16_i
                ldi     @0, HIGH(@2)
                ldi     @1, LOW(@2)
.endm



.macro peek16
  .message "no parameters specified"
.endm

.macro peek16_16_i
                lds     @1, @2
                lds     @0, @2 + 1
.endm



.macro poke16
  .message "no parameters specified"
.endm

.macro poke16_i_16
                sts     @0, @2
                sts     @0 + 1, @1
.endm



.macro poke16Y
  .message "no parameters specified"
.endm

.macro poke16Y_i
                ldi     r16, LOW(@0)
                st      Y+, r16
                ldi     r16, HIGH(@0)
                st      Y+, r16
.endm

.macro push16
  .message "no parameters specified"
.endm

.macro push16_16
                push    @0
                push    @1
.endm

.macro pop16
  .message "no parameters specified"
.endm

.macro pop16_16
                pop    @1
                pop    @0
.endm

; .macro schowreg
;   .message "no parameters specified"
; .endm
; 
; .macro schowreg_8
;                 mov     r16, @0
;                 com     r16
;                 sts     led_reg + 6, r16
; .endm
 
