.CSEG
.nolist

.include        "tn24def.inc"
.include        "macro.inc"

.org 0
.list

.def    const_0 = r2
.def    const_1 = r3

.def    varA    = r20
.def    varB    = r21
.def    varC    = r22
.def    varD    = r23
.def    Kom     = r16
.def    Dat     = r17


.equ    CPUF    = 8000000

.equ    TAST    = PINB
.equ    S1      = PB0
.equ    S2      = PB1

.equ    STSR    = GPIOR0
.equ    SDAT    = GPIOR00       ; Befehl/Daten
.equ    SCHG    = GPIOR01       ; geändert
.equ    SCHI    = GPIOR02       ; beim Ändern

.equ    soSP    = 32

; .equ    pPC     = r26:r27
; .equ    PC      = X
; .equ    pSP     = YL:YH
; .equ    SP      = Y

; Disassembly of TPS-t44-1.bin (AVR instruction set style)

; rjmp    Label1
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti
; reti

; Referenced from offset 0x00 by rjmp
; Label1:
ldi     r16, low(RAMEND)
; ldi     r24, 0x5f       ; 95
out     SPL, r16
; ldi     r28, 0x40       ; 64
; ldi     r30, 0x18       ; 24
; mov     r4, r30
; ldi     r24, 0x01       ; 1
; out     SPH, r24
; ldi     r29, 0x01       ; 1
; ldi     r31, 0x01       ; 1
; mov     r5, r31
; ldi     r30, 0xfe       ; 254
; ldi     r31, 0x00       ; 0
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0

wdr
ldi r16, (0<<WDRF)
out MCUSR, r16
in r16, WDTCSR
ori r16, (1<<WDCE)|(1<<WDE)
out WDTCSR, r16
ldi r16, (0<<WDE)
out WDTCSR, r16

; wdr
; in      r24, MCUSR
; mov     r0, r24
; cbr     r24, 0x08       ; 8
; out     MCUSR, r24
; ldi     r24, 0x18       ; 24
; clr     r25
; out     WDTCR, r24
; out     WDTCR, r25
; clr     r24

; Referenced from offset 0x56 by brne
; Label2:
; st      X+, r24
; sbiw    r30, 0x01    ; 1
; brne    Label2
; clr     r6
clr     const_0
mov     const_1, const_0
inc     const_1


ldi     r24, 1<<DDB2            ; PWM
out     DDRB, r24
ldi     r24, 1<<DDB0|1<<DDB1	; S1, S2
out     PORTB, r24
ldi     r24, 0x0f               ; Ausg. 0-3
out     DDRA, r24
ldi     r24, 0xf0               ; Eing. 0-3
out     PORTA, r24

ldi     r24, 1<<CLKPCE 
out     CLKPR, r24
clr     r24
out     CLKPR, r24
out     CLKPR, r24

; ldi     r24, 0x80       ; 128
; out     ICR1L, r24
; ldi     r24, 0x00       ; 0
; out     ICR1L, r24
; ldi     r24, 0x00       ; 0
; out     ICR1L, r24

ldi     r24, 1<<ADEN|6
out     ADCSRA, r24
;ldi     r24, 0x00       ; 0
out     ADMUX, const_0
sbi     ACSR, ACD

ldi     r24, 2          ; clkI/O/8 (From prescaler)
out     TCCR0B, r24
ldi     r24, 1<<COM0A1 | 1<<COM0A0 | 1<<WGM00
out     TCCR0A, r24
ser     r24
out     OCR0A, r24
; out     TCCR0, r24
; ldi     r24, 0xc1       ; 193
; out     SFIOR, r24
; ser     r24
; sts     0x0056, r24
; ldi     r24, 0xc1       ; 193
; out     TCCR0, r24

; ldi     r24, 0xc8       ; 200
; ldi     r25, 0x00       ; 0
ld16    [r25:r24, 400]
rcall   wait_ms

; ser     r16
; out     PORTA, r16
; hier:
; rjmp    hier

sbis    TAST, S2        ; nicht gedrückt
rjmp	programmieren

ausfuehren:
ld16      [YH:YL, SP]
ld16      [XH:XL, 0]

ausf_loop:
ld16    [r17:r16, EEPROMEND - 4]
sub     r16, XL
sbc     r17, XH
brsh    ausf_nerr

ausf_pcerr:
ser     r16             ; Fehler Programmzähler

ausf_err:               ; evtl. Fehleradresse anzeigen !!!!!!!!!!!!!!!!!!!
out     PORTA, r16
inc     r17
out     OCR0A, r17
ld16    [r25:r24, 5]
rcall   wait_ms
rjmp    ausf_err

ausf_nerr:
; rjmp    ausf_nerr
rcall   EEPROM_read
adiw    XL, 1
mov     r17, r16
swap	r16
andi	Kom, 0xf        ; Befehl
andi    Dat, 0xf        ; Daten

; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label3
; ldi     r16, 0x01       ; 1

; Referenced from offset 0xa2 by brtc
; Label3:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label4
; rjmp    Label5

; Referenced from offset 0xaa by breq
; Label4:
; rjmp    Label195
; rjmp    Label195

; Referenced from offset 0xac by rjmp
; Label5:
; ldi     r24, 0x00       ; 0
; sts     0x0060, r24

; Referenced from offset 0x91e by rjmp
; Label6:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r30, X
; clr     r31
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; ldi     r25, 0x01       ; 1
; rcall   Function14
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r20, 0x0f       ; 15
; and     r16, r20
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; st      X, r16
; ldi     r20, 0x10       ; 16
; rcall   Function16
; ldi     r26, 0x63       ; 99
; ldi     r27, 0x00       ; 0
; st      X, r16
; cpi     r16, 0x01       ; 1
; breq    Label7
; rjmp    Label8

cpi     Kom, 1          ; Befehl "1" direkte Portausgabe
brne	ausf_tb2
ori     Dat, 0xf0
out     PORTA, Dat
; hier:
; rjmp hier

; Referenced from offset 0xf4 by breq
; Label7:
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27

; Referenced from offset 0xf6 by rjmp
; Label8:
; cpi     r16, 0x02       ; 2
; breq    Label9
; rjmp    Label41

ausf_tb2:
cpi     Kom, 2          ; Befehl "2" warte
brne    ausf_tb3
ld16    [r25:r24, 1]
cpi     Dat, 0
breq    ausf_b2
ldi     r24, 2
cpi     Dat, 1
breq    ausf_b2
ldi     r24, 5
cpi     Dat, 2
breq    ausf_b2
ldi     r24, 10
cpi     Dat, 3
breq    ausf_b2
ldi     r24, 20
cpi     Dat, 4
breq    ausf_b2
ldi     r24, 50
cpi     Dat, 5
breq    ausf_b2
ldi     r24, 100
cpi     Dat, 6
breq    ausf_b2
ldi     r24, 200
cpi     Dat, 7
breq    ausf_b2
ld16    [r25:r24, 500]
cpi     Dat, 8
breq    ausf_b2
ld16    [r25:r24, 1000]
cpi     Dat, 9
breq    ausf_b2
ld16    [r25:r24, 2000]
cpi     Dat, 10
breq    ausf_b2
ld16    [r25:r24, 5000]
cpi     Dat, 11
breq    ausf_b2
ld16    [r25:r24, 10000]
cpi     Dat, 12
breq    ausf_b2
ld16    [r25:r24, 20000]
cpi     Dat, 13
breq    ausf_b2
ld16    [r25:r24, 30000]
cpi     Dat, 14
breq    ausf_b2
ld16    [r25:r24, 60000]
ausf_b2:
rcall   wait_ms

; Referenced from offset 0x108 by breq
; Label9:
; cpi     r16, 0x00       ; 0
; breq    Label10
; rjmp    Label11

; Referenced from offset 0x112 by breq
; Label10:
; ldi     r24, 0x01       ; 1
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x114 by rjmp
; Label11:
; cpi     r16, 0x01       ; 1
; breq    Label12
; rjmp    Label13

; Referenced from offset 0x122 by breq
; Label12:
; ldi     r24, 0x02       ; 2
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x124 by rjmp
; Label13:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x02       ; 2
; breq    Label14
; rjmp    Label15

; Referenced from offset 0x132 by breq
; Label14:
; ldi     r24, 0x05       ; 5
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x134 by rjmp
; Label15:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x03       ; 3
; breq    Label16
; rjmp    Label17

; Referenced from offset 0x142 by breq
; Label16:
; ldi     r24, 0x0a       ; 10
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x144 by rjmp
; Label17:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x04       ; 4
; breq    Label18
; rjmp    Label19

; Referenced from offset 0x152 by breq
; Label18:
; ldi     r24, 0x14       ; 20
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x154 by rjmp
; Label19:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x05       ; 5
; breq    Label20
; rjmp    Label21

; Referenced from offset 0x162 by breq
; Label20:
; ldi     r24, 0x32       ; 50
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x164 by rjmp
; Label21:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x06       ; 6
; breq    Label22
; rjmp    Label23

; Referenced from offset 0x172 by breq
; Label22:
; ldi     r24, 0x64       ; 100
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x174 by rjmp
; Label23:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x07       ; 7
; breq    Label24
; rjmp    Label25

; Referenced from offset 0x182 by breq
; Label24:
; ldi     r24, 0xc8       ; 200
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x184 by rjmp
; Label25:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x08       ; 8
; breq    Label26
; rjmp    Label27

; Referenced from offset 0x192 by breq
; Label26:
; ldi     r24, 0xf4       ; 244
; ldi     r25, 0x01       ; 1
; rcall   wait_ms

; Referenced from offset 0x194 by rjmp
; Label27:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x09       ; 9
; breq    Label28
; rjmp    Label29

; Referenced from offset 0x1a2 by breq
; Label28:
; ldi     r24, 0xe8       ; 232
; ldi     r25, 0x03       ; 3
; rcall   wait_ms

; Referenced from offset 0x1a4 by rjmp
; Label29:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0a       ; 10
; breq    Label30
; rjmp    Label31

; Referenced from offset 0x1b2 by breq
; Label30:
; ldi     r24, 0xd0       ; 208
; ldi     r25, 0x07       ; 7
; rcall   wait_ms

; Referenced from offset 0x1b4 by rjmp
; Label31:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0b       ; 11
; breq    Label32
; rjmp    Label33

; Referenced from offset 0x1c2 by breq
; Label32:
; ldi     r24, 0x88       ; 136
; ldi     r25, 0x13       ; 19
; rcall   wait_ms

; Referenced from offset 0x1c4 by rjmp
; Label33:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0c       ; 12
; breq    Label34
; rjmp    Label35

; Referenced from offset 0x1d2 by breq
; Label34:
; ldi     r24, 0x10       ; 16
; ldi     r25, 0x27       ; 39
; rcall   wait_ms

; Referenced from offset 0x1d4 by rjmp
; Label35:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0d       ; 13
; breq    Label36
; rjmp    Label37

; Referenced from offset 0x1e2 by breq
; Label36:
; ldi     r24, 0x20       ; 32
; ldi     r25, 0x4e       ; 78
; rcall   wait_ms

; Referenced from offset 0x1e4 by rjmp
; Label37:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0e       ; 14
; breq    Label38
; rjmp    Label39

; Referenced from offset 0x1f2 by breq
; Label38:
; ldi     r24, 0x30       ; 48
; ldi     r25, 0x75       ; 117
; rcall   wait_ms

; Referenced from offset 0x1f4 by rjmp
; Label39:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0f       ; 15
; breq    Label40
; rjmp    Label41

; Referenced from offset 0x202 by breq
; Label40:
; ldi     r24, 0x60       ; 96
; ldi     r25, 0xea       ; 234
; rcall   wait_ms

; Referenced from offset 0x10a by rjmp
; Referenced from offset 0x204 by rjmp
; Label41:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x03       ; 3
; breq    Label42
; rjmp    Label43

ausf_tb3:
cpi     Kom, 3          ; Befehl "3" relativer Rücksprung
brne    ausf_tb4
sbiw    XL, 1
sub     XL, Dat
sbc     XH, const_0
brcc    ausf_tb4        ; Bereichsüberschreitung?
rjmp    ausf_err

; Referenced from offset 0x212 by breq
; Label42:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0x01       ; 1
; st      X, r24
; lds    r16, 0x0060      
; lds    r20, 0x0062     ; dat
; sub     r16, r20
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x214 by rjmp
; Label43:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x04       ; 4
; breq    Label44
; rjmp    Label45

ausf_tb4:
cpi     Kom, 4          ; Befehl "4" lade A direkt
brne    ausf_tb5
mov     varA, Dat


; Referenced from offset 0x236 by breq
; Label44:
; lds    r24, 0x0062     ; dat
; sts     0x006a, r24     ; varA

; Referenced from offset 0x238 by rjmp
; Label45:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x05       ; 5
; breq    Label46
; rjmp    Label76

ausf_tb5:
cpi     Kom, 5          ; Befehl "5" schreibe A
brne    ausf_tb6

cpi     Dat, 1          ; in B
brne    ausf_b5t2
mov     varB, varA

ausf_b5t2:
cpi     Dat, 2          ; in C
brne    ausf_b5t3
mov     varC, varA      

ausf_b5t3:
cpi     Dat, 3          ; in D
brne    ausf_b5t4
mov     varD, varA

ausf_b5t4:
cpi     Dat, 4          ; in Ausgabe
brne    ausf_b5t5
mov     r24, varA
ori     r24, 0xF0
out     PORTA, r24

ausf_b5t5:
cpi     Dat, 5          ; Bit0 in Ausgang 0
brne    ausf_b5t6
ldi     r24, 1<<PA0
rjmp    ausf_b55_8

ausf_b5t6:
cpi     Dat, 6          ; Bit0 in Ausgang 1
brne    ausf_b5t7
ldi     r24, 1<<PA1
rjmp    ausf_b55_8


ausf_b5t7:
cpi     Dat, 7          ; Bit0 in Ausgang 2
brne    ausf_b5t8
ldi     r24, 1<<PA2
rjmp    ausf_b55_8

ausf_b5t8:
cpi     Dat, 8          ; Bit0 in Ausgang 3
brne    ausf_b5t9
ldi     r24, 1<<PA3

ausf_b55_8:
in      r25, PORTA
bst     varA, 0
brts    ausf_b5t8s
com     r24
and     r25, r24
rjmp    ausf_b5t8e

ausf_b5t8s:
or      r25, r24

ausf_b5t8e:
ori     r25, 0xf0
out     PORTA, r25

ausf_b5t9:
cpi     Dat, 9          ; in PWM
brne    ausf_b5tA
mov     r24, varA
swap    r24
add     r24, varA
com     r24
out     OCR0A, r24

ausf_b5tA:

; Referenced from offset 0x248 by breq
; Label46:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x01       ; 1
; breq    Label47
; rjmp    Label48

; Referenced from offset 0x252 by breq
; Label47:
; lds    r24, 0x006a     ; varA
; sts     0x006b, r24     ; varB

; Referenced from offset 0x254 by rjmp
; Label48:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x02       ; 2
; breq    Label49
; rjmp    Label50

; Referenced from offset 0x264 by breq
; Label49:
; lds    r24, 0x006a     ; varA
; sts     0x006c, r24     ; varC

; Referenced from offset 0x266 by rjmp
; Label50:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x03       ; 3
; breq    Label51
; rjmp    Label52

; Referenced from offset 0x276 by breq
; Label51:
; lds    r24, 0x006a     ; varA
; sts     0x006d, r24     ; varD

; Referenced from offset 0x278 by rjmp
; Label52:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x04       ; 4
; breq    Label53
; rjmp    Label54

; Referenced from offset 0x288 by breq
; Label53:
; lds    r16, 0x006a     ; varA
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27

; Referenced from offset 0x28a by rjmp
; Label54:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x05       ; 5
; breq    Label55
; rjmp    Label59

; Referenced from offset 0x29c by breq
; Label55:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r16, X
; bst     r16, 0          ; 0x01 = 1
; clr     r16
; brtc    Label56
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x2aa by brtc
; Label56:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label57
; rjmp    Label58

; Referenced from offset 0x2b2 by breq
; Label57:
; cbi     0x1b, 0         ; 0x01 = 1
; rjmp    Label59

; Referenced from offset 0x2b4 by rjmp
; Label58:
; sbi     0x1b, 0         ; 0x01 = 1

; Referenced from offset 0x29e by rjmp
; Referenced from offset 0x2b8 by rjmp
; Label59:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x06       ; 6
; breq    Label60
; rjmp    Label64

; Referenced from offset 0x2c2 by breq
; Label60:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r16, X
; bst     r16, 0          ; 0x01 = 1
; clr     r16
; brtc    Label61
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x2d0 by brtc
; Label61:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label62
; rjmp    Label63

; Referenced from offset 0x2d8 by breq
; Label62:
; cbi     0x1b, 1         ; 0x02 = 2
; rjmp    Label64

; Referenced from offset 0x2da by rjmp
; Label63:
; sbi     0x1b, 1         ; 0x02 = 2

; Referenced from offset 0x2c4 by rjmp
; Referenced from offset 0x2de by rjmp
; Label64:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x07       ; 7
; breq    Label65
; rjmp    Label69

; Referenced from offset 0x2e8 by breq
; Label65:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r16, X
; bst     r16, 0          ; 0x01 = 1
; clr     r16
; brtc    Label66
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x2f6 by brtc
; Label66:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label67
; rjmp    Label68

; Referenced from offset 0x2fe by breq
; Label67:
; cbi     0x1b, 2         ; 0x04 = 4
; rjmp    Label69

; Referenced from offset 0x300 by rjmp
; Label68:
; sbi     0x1b, 2         ; 0x04 = 4

; Referenced from offset 0x2ea by rjmp
; Referenced from offset 0x304 by rjmp
; Label69:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x08       ; 8
; breq    Label70
; rjmp    Label74

; Referenced from offset 0x30e by breq
; Label70:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r16, X
; bst     r16, 0          ; 0x01 = 1
; clr     r16
; brtc    Label71
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x31c by brtc
; Label71:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label72
; rjmp    Label73

; Referenced from offset 0x324 by breq
; Label72:
; cbi     0x1b, 3         ; 0x08 = 8
; rjmp    Label74

; Referenced from offset 0x326 by rjmp
; Label73:
; sbi     0x1b, 3         ; 0x08 = 8

; Referenced from offset 0x310 by rjmp
; Referenced from offset 0x32a by rjmp
; Label74:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x09       ; 9
; breq    Label75
; rjmp    Label76

; Referenced from offset 0x334 by breq
; Label75:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r16, X+
; clr     r17
; ldi     r20, 0x11       ; 17
; ldi     r21, 0x00       ; 0
; rcall   Function8
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; st      X+, r16
; st      X, r17
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; ldi     r30, 0x56       ; 86
; ldi     r31, 0x00       ; 0
; ldi     r20, 0x02       ; 2
; rcall   Function1

; Referenced from offset 0x24a by rjmp
; Referenced from offset 0x336 by rjmp
; Label76:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x06       ; 6
; breq    Label77
; rjmp    Label97

ausf_tb6:
cpi     Kom, 6          ; Befehl "6" Lade A
brne    ausf_tb7

cpi     Dat, 1          ; aus B
brne    ausf_b6t02
mov     varA, varB

ausf_b6t02:
cpi     Dat, 2          ; aus C
brne    ausf_b6t03
mov     varA, varC

ausf_b6t03:
cpi     Dat, 3          ; aus D
brne    ausf_b6t04
mov     varA, varD

ausf_b6t04:
in      r24, PINA
swap    r24
andi    r24, 0xf

cpi     Dat, 4          ; aus Eingang
brne    ausf_b6t05
mov     varA, r24

ausf_b6t05:
cpi     Dat, 5          ; Bit0 aus Eingang 0
brne    ausf_b6t06
bst     r24, 0
rjmp    ausf_b6t05_8

ausf_b6t06:
cpi     Dat, 6          ; Bit0 aus Eingang 1
brne    ausf_b6t07
bst     r24, 1
rjmp    ausf_b6t05_8

ausf_b6t07:
cpi     Dat, 7          ; Bit0 aus Eingang 2
brne    ausf_b6t08
bst     r24, 2
rjmp    ausf_b6t05_8

ausf_b6t08:
cpi     Dat, 8          ; Bit0 aus Eingang 3
brne    ausf_b6t09
bst     r24, 3

ausf_b6t05_8:
clr     varA
bld     varA, 0

ausf_b6t09:
cpi     Dat, 9          ; aus ADC Eingang 0 (Eingang 2)
brne    ausf_b6t10
ldi     r24, ADCH6
rjmp    ausf_b6t09_10

ausf_b6t10:
cpi     Dat, 10         ; aus ADC Eingang 1 (Eingang 3)
brne    ausf_b6t11
ldi     r24, ADCH7

ausf_b6t09_10:
out     ADMUX, r24
sbi     ADCSRA, ADSC

ausf_b6t09_10a:
sbic    ADCSRA, ADSC
rjmp    ausf_b6t09_10a
in      r24, ADCL
in      r25, ADCH

lsr     r25
ror     r24
lsr     r25
ror     r24
swap    r24
andi    r24, 0xf

 ; ldi     r16, 6
 ; ausf_b6t09_10b:
 ; lsr     r25
 ; ror     r24
 ; dec     r16
 ; brne    ausf_b6t09_10b

mov     varA, r24

;sbi     ADCSR, 6        ; 0x40 = 64

; Referenced from offset 0xcda by rjmp
; Label251:
; sbic    ADCSR, 6        ; 0x40 = 64
; rjmp    Label251
; sbi     ADCSR, 6        ; 0x40 = 64

; Referenced from offset 0xce0 by rjmp
; Label252:
; sbic    ADCSR, 6        ; 0x40 = 64
; rjmp    Label252
; in      r24, ADCL
; in      r25, ADCH

ausf_b6t11:

; Referenced from offset 0x360 by breq
; Label77:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x01       ; 1
; breq    Label78
; rjmp    Label79

; Referenced from offset 0x36a by breq
; Label78:
; lds    r24, 0x006b     ; varB
; sts     0x006a, r24     ; varA

; Referenced from offset 0x36c by rjmp
; Label79:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x02       ; 2
; breq    Label80
; rjmp    Label81

; Referenced from offset 0x37c by breq
; Label80:
; lds    r24, 0x006c     ; varC
; sts     0x006a, r24     ; varA

; Referenced from offset 0x37e by rjmp
; Label81:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x03       ; 3
; breq    Label82
; rjmp    Label83

; Referenced from offset 0x38e by breq
; Label82:
; lds    r24, 0x006d     ; varD
; sts     0x006a, r24     ; varA

; Referenced from offset 0x390 by rjmp
; Label83:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x04       ; 4
; breq    Label84
; rjmp    Label85

; Referenced from offset 0x3a0 by breq
; Label84:
; in      r16, 0x19       ; 25
; ldi     r20, 0xf0       ; 240
; and     r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16
; ldi     r25, 0x04       ; 4
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; rcall   Function11

; Referenced from offset 0x3a2 by rjmp
; Label85:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x05       ; 5
; breq    Label86
; rjmp    Label87

; Referenced from offset 0x3be by breq
; Label86:
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 4          ; 0x10 = 16
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; clr     r24
; bld     r24, 0          ; 0x01 = 1
; st      X, r24

; Referenced from offset 0x3c0 by rjmp
; Label87:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x06       ; 6
; breq    Label88
; rjmp    Label89

; Referenced from offset 0x3da by breq
; Label88:
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 5          ; 0x20 = 32
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; clr     r24
; bld     r24, 0          ; 0x01 = 1
; st      X, r24

; Referenced from offset 0x3dc by rjmp
; Label89:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x07       ; 7
; breq    Label90
; rjmp    Label91

; Referenced from offset 0x3f6 by breq
; Label90:
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 6          ; 0x40 = 64
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; clr     r24
; bld     r24, 0          ; 0x01 = 1
; st      X, r24

; Referenced from offset 0x3f8 by rjmp
; Label91:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x08       ; 8
; breq    Label92
; rjmp    Label93

; Referenced from offset 0x412 by breq
; Label92:
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 7          ; 0x80 = 128
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; clr     r24
; bld     r24, 0          ; 0x01 = 1
; st      X, r24

; Referenced from offset 0x414 by rjmp
; Label93:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x09       ; 9
; breq    Label94
; rjmp    Label95

; Referenced from offset 0x42e by breq
; Label94:
; in      r16, ADMUX
; andi    r16, 0xc0       ; 192
; ori     r16, 0x06       ; 6
; out     ADMUX, r16
; rcall   Function10
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; st      X+, r24
; st      X, r25
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; ld      r16, X+
; ld      r17, X
; ldi     r20, 0x40       ; 64
; ldi     r21, 0x00       ; 0
; rcall   Function7
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; st      X+, r20
; st      X, r21
; lds    r24, 0x0068      
; sts     0x006a, r24     ; varA

; Referenced from offset 0x430 by rjmp
; Label95:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0a       ; 10
; breq    Label96
; rjmp    Label97

; Referenced from offset 0x468 by breq
; Label96:
; in      r16, ADMUX
; andi    r16, 0xc0       ; 192
; ori     r16, 0x07       ; 7
; out     ADMUX, r16
; rcall   Function10
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; st      X+, r24
; st      X, r25
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; ld      r16, X+
; ld      r17, X
; ldi     r20, 0x40       ; 64
; ldi     r21, 0x00       ; 0
; rcall   Function7
; ldi     r26, 0x68       ; 104
; ldi     r27, 0x00       ; 0
; st      X+, r20
; st      X, r21
; lds    r24, 0x0068      
; sts     0x006a, r24     ; varA

; Referenced from offset 0x362 by rjmp
; Referenced from offset 0x46a by rjmp
; Label97:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x07       ; 7
; breq    Label98
; rjmp    Label119

ausf_tb7:
cpi     Kom, 7          ; Befehl "7" rechne mit A
brne    ausf_tb8

cpi     Dat, 1          ; incrementiere
brne    ausf_b7t02
inc     varA

ausf_b7t02:
cpi     Dat, 2          ; decrementiere
brne    ausf_b7t03
dec     varA

ausf_b7t03:
cpi     Dat, 3          ; addiere B
brne    ausf_b7t04
add     varA, varB

ausf_b7t04:
cpi     Dat, 4          ; subtrahiere B
brne    ausf_b7t05
sub     varA, varB

ausf_b7t05:
cpi     Dat, 5          ; multipliziere
brne    ausf_b7t06
 ; Multiplikation varA x varB -> varA
clr     r24
ldi     r25, 8
lsr     varA

ausf_b7t06mul0:
brcc    ausf_b7t06mul1
add     r24, varB

ausf_b7t06mul1:
ror     r24
ror     varA
dec     r25
brne    ausf_b7t06mul0

ausf_b7t06:
cpi     Dat, 6          ; dividiere durch B
brne    ausf_b7t07
 ; Division varA / varB -> varA
sub     r24, r24
ldi     r25, 9

ausf_b7t06div0:
rol     varA
dec     r25
breq    ausf_b7t06dive
rol     r24
sub     r24, varB
brcc    ausf_b7t06divp
add     r24, varB
clc
rjmp    ausf_b7t06div0

ausf_b7t06divp:
sec
rjmp    ausf_b7t06div0

ausf_b7t06dive:

ausf_b7t07:
cpi     Dat, 7          ; logisches Und mit B
brne    ausf_b7t08
and     varA, varB

ausf_b7t08:
cpi     Dat, 8          ; logisches Oder mit B
brne    ausf_b7t09
or      varA, varB

ausf_b7t09:
cpi     Dat, 9          ; logisches Exclusivoder mit B
brne    ausf_b7t10
eor     varA, varB

ausf_b7t10:
cpi     Dat, 10         ; nicht
brne    ausf_b7t11
com     varA

ausf_b7t11:
andi    varA, 0xf       ; auf Zahlenbereich 0 .. 15 begrenzen

; Referenced from offset 0x4a2 by breq
; Label98:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x01       ; 1
; breq    Label99
; rjmp    Label100

; Referenced from offset 0x4ac by breq
; Label99:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x4ae by rjmp
; Label100:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x02       ; 2
; breq    Label101
; rjmp    Label102

; Referenced from offset 0x4c0 by breq
; Label101:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0x01       ; 1
; st      X, r24

; Referenced from offset 0x4c2 by rjmp
; Label102:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x03       ; 3
; breq    Label103
; rjmp    Label104

; Referenced from offset 0x4d4 by breq
; Label103:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; add     r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x4d6 by rjmp
; Label104:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x04       ; 4
; breq    Label105
; rjmp    Label106

; Referenced from offset 0x4ee by breq
; Label105:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; sub     r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x4f0 by rjmp
; Label106:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x05       ; 5
; breq    Label107
; rjmp    Label108

; Referenced from offset 0x508 by breq
; Label107:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; rcall   Function15
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r20

; Referenced from offset 0x50a by rjmp
; Label108:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x06       ; 6
; breq    Label109
; rjmp    Label110

; Referenced from offset 0x522 by breq
; Label109:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; rcall   Function16
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x524 by rjmp
; Label110:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x07       ; 7
; breq    Label111
; rjmp    Label112

; Referenced from offset 0x53c by breq
; Label111:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; and     r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x53e by rjmp
; Label112:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x08       ; 8
; breq    Label113
; rjmp    Label114

; Referenced from offset 0x556 by breq
; Label113:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; or      r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x558 by rjmp
; Label114:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x09       ; 9
; breq    Label115
; rjmp    Label116

; Referenced from offset 0x570 by breq
; Label115:
; lds    r16, 0x006a     ; varA
; lds    r20, 0x006b     ; varB
; eor     r16, r20
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x572 by rjmp
; Label116:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x0a       ; 10
; breq    Label117
; rjmp    Label118

; Referenced from offset 0x58a by breq
; Label117:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r24, X
; com     r24
; st      X, r24

; Referenced from offset 0x58c by rjmp
; Label118:
; ldi     r26, 0x6a       ; 106
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24

; Referenced from offset 0x4a4 by rjmp
; Label119:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x08       ; 8
; breq    Label120
; rjmp    Label121

ausf_tb8:
cpi     Kom, 8          ; Befehl "8" setze Sprungseite
brne    ausf_tb9
sts     AddrHi, Dat

; Referenced from offset 0x5a8 by breq
; Label120:
; lds    r24, 0x0062     ; dat
; sts     0x0064, r24     ; adrHi

; Referenced from offset 0x5aa by rjmp
; Label121:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x09       ; 9
; breq    Label122
; rjmp    Label123

ausf_tb9:
cpi     Kom, 9          ; Befehl "9" springe absolut
brne    ausf_tb10

ausf_jump:
lds     XL, AddrHi
swap    XL
andi    XL, 0xf0
add     XL, Dat
rjmp    ausf_loop

; Referenced from offset 0x5ba by breq
; Label122:
; lds    r16, 0x0064     ; adrHi
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds    r16, 0x0060      
; lds    r20, 0x0062     ; dat
; add     r16, r20
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x5bc by rjmp
; Label123:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x0a       ; 10
; breq    Label124
; rjmp    Label127

ausf_tb10:
cpi     Kom, 10          ; Befehl "10" wenn C != 0, springe absolut und dekrementiere C
brne    ausf_tb11
tst     varC
breq    ausf_tb10e
dec     varC
rjmp    ausf_jump

ausf_tb10e:

; Label124:
; Referenced from offset 0x5e2 by breq
; lds    r16, 0x006c     ; varC
; cpi     r16, 0x00       ; 0
; brcs    Label125
; breq    Label125
; rjmp    Label126

; Referenced from offset 0x5ec by brcs
; Referenced from offset 0x5ee by breq
; Label125:
; rjmp    Label127

; Referenced from offset 0x5f0 by rjmp
; Label126:
; ldi     r26, 0x6c       ; 108
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0x01       ; 1
; st      X, r24
; ldi     r26, 0x6c       ; 108
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds    r16, 0x0064     ; adrHi
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds    r16, 0x0060      
; lds    r20, 0x0062     ; dat
; add     r16, r20
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x5e4 by rjmp
; Referenced from offset 0x5f2 by rjmp
; Label127:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x0b       ; 11
; breq    Label128
; rjmp    Label131

ausf_tb11:
cpi     Kom, 11          ; Befehl "11" wenn D != 0, springe absolut und dekrementiere D
brne    ausf_tb12
tst     varD
breq    ausf_tb11e
dec     varD
rjmp    ausf_jump

ausf_tb11e:

; Referenced from offset 0x62c by breq
; Label128:
; lds    r16, 0x006d     ; varD
; cpi     r16, 0x00       ; 0
; brcs    Label129
; breq    Label129
; rjmp    Label130

; Referenced from offset 0x636 by brcs
; Referenced from offset 0x638 by breq
; Label129:
; rjmp    Label131

; Referenced from offset 0x63a by rjmp
; Label130:
; ldi     r26, 0x6d       ; 109
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0x01       ; 1
; st      X, r24
; ldi     r26, 0x6d       ; 109
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds    r16, 0x0064     ; adrHi
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds    r16, 0x0060      
; lds    r20, 0x0062     ; dat
; add     r16, r20
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x62e by rjmp
; Referenced from offset 0x63c by rjmp
; Label131:
; lds    r16, 0x0063     ; kom
; cpi     r16, 0x0c       ; 12
; breq    Label132
; rjmp    Label190

ausf_tb12:
cpi     Kom, 12          ; Befehl "12" überspringe den nächsten Befehl, wenn
brne    ausf_tb13

cpi     Dat, 1           ; A > B
brne    ausf_b12t02
cp      varB, varA
brsh    ausf_b12t02
adiw    XL, 1

ausf_b12t02:
cpi     Dat, 2           ; A < B
brne    ausf_b12t03
cp      varA, varB
brsh    ausf_b12t03
adiw    XL, 1

ausf_b12t03:
cpi     Dat, 3           ; A == B
brne    ausf_b12t04
cp      varA, varB
brne    ausf_b12t04
adiw    XL, 1

ausf_b12t04:             ; Eingang 0 high
cpi     Dat, 4
brne    ausf_b12t05
sbic    PINA, 4
adiw    XL, 1

ausf_b12t05:
cpi     Dat, 5           ; Eingang 1 high
brne    ausf_b12t06
sbic    PINA, 5
adiw    XL, 1

ausf_b12t06:
cpi     Dat, 6           ; Eingang 2 high
brne    ausf_b12t07
sbic    PINA, 6
adiw    XL, 1

ausf_b12t07:
cpi     Dat, 7           ; Eingang 3 high
brne    ausf_b12t08
sbic    PINA, 7
adiw    XL, 1

ausf_b12t08:
cpi     Dat, 8           ; Eingang 0 low
brne    ausf_b12t09
sbis    PINA, 4
adiw    XL, 1

ausf_b12t09:
cpi     Dat, 9           ; Eingang 1 low
brne    ausf_b12t10
sbis    PINA, 5
adiw    XL, 1

ausf_b12t10:
cpi     Dat, 10          ; Eingang 2 low
brne    ausf_b12t11
sbis    PINA, 6
adiw    XL, 1

ausf_b12t11:
cpi     Dat, 11          ; Eingang 3 low
brne    ausf_b12t12
sbis    PINA, 7
adiw    XL, 1

ausf_b12t12:
cpi     Dat, 12          ; S1 gedrückt
brne    ausf_b12t13
sbis    TAST, S1
adiw    XL, 1

ausf_b12t13:
cpi     Dat, 13          ; S2 gedrückt
brne    ausf_b12t14
sbis    TAST, S2
adiw    XL, 1

ausf_b12t14:
cpi     Dat, 14          ; S1 nicht gedrückt
brne    ausf_b12t15
sbic    TAST, S1
adiw    XL, 1

ausf_b12t15:
cpi     Dat, 15          ; S2 nicht gedrückt
brne    ausf_b12t16
sbic    TAST, S2
adiw    XL, 1

ausf_b12t16:

; Referenced from offset 0x676 by breq
; Label132:
; lds    r16, 0x0062     ; dat
; cpi     r16, 0x01       ; 1
; breq    Label133
; rjmp    Label136

; Referenced from offset 0x680 by breq
; Label133:
; lds    r20, 0x006b     ; varB
; lds    r16, 0x006a     ; varA
; cp      r16, r20
; brcs    Label134
; breq    Label134
; rjmp    Label135

; Referenced from offset 0x68e by brcs
; Referenced from offset 0x690 by breq
; Label134:
; rjmp    Label136

; Referenced from offset 0x692 by rjmp
; Label135:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x682 by rjmp
; Referenced from offset 0x694 by rjmp
; Label136:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x02       ; 2
; breq    Label137
; rjmp    Label139

; Referenced from offset 0x6a6 by breq
; Label137:
; lds     0x006b, r20     ; varB
; lds     0x006a, r16     ; varA
; cp      r16, r20
; brcs    Label138
; rjmp    Label139

; Referenced from offset 0x6b4 by brcs
; Label138:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x6a8 by rjmp
; Referenced from offset 0x6b6 by rjmp
; Label139:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x03       ; 3
; breq    Label140
; rjmp    Label142

; Referenced from offset 0x6c8 by breq
; Label140:
; lds     0x006b, r20     ; varB
; lds     0x006a, r16     ; varA
; cp      r16, r20
; breq    Label141
; rjmp    Label142

; Referenced from offset 0x6d6 by breq
; Label141:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x6ca by rjmp
; Referenced from offset 0x6d8 by rjmp
; Label142:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x04       ; 4
; breq    Label143
; rjmp    Label146

; Referenced from offset 0x6ea by breq
; Label143:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 4          ; 0x10 = 16
; brtc    Label144
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x6f8 by brtc
; Label144:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label145
; rjmp    Label146

; Referenced from offset 0x700 by breq
; Label145:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x6ec by rjmp
; Referenced from offset 0x702 by rjmp
; Label146:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x05       ; 5
; breq    Label147
; rjmp    Label150

; Referenced from offset 0x714 by breq
; Label147:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 5          ; 0x20 = 32
; brtc    Label148
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x722 by brtc
; Label148:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label149
; rjmp    Label150

; Referenced from offset 0x72a by breq
; Label149:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x716 by rjmp
; Referenced from offset 0x72c by rjmp
; Label150:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x06       ; 6
; breq    Label151
; rjmp    Label154

; Referenced from offset 0x73e by breq
; Label151:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 6          ; 0x40 = 64
; brtc    Label152
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x74c by brtc
; Label152:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label153
; rjmp    Label154

; Referenced from offset 0x754 by breq
; Label153:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x740 by rjmp
; Referenced from offset 0x756 by rjmp
; Label154:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x07       ; 7
; breq    Label155
; rjmp    Label158

; Referenced from offset 0x768 by breq
; Label155:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 7          ; 0x80 = 128
; brtc    Label156
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x776 by brtc
; Label156:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label157
; rjmp    Label158

; Referenced from offset 0x77e by breq
; Label157:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x76a by rjmp
; Referenced from offset 0x780 by rjmp
; Label158:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x08       ; 8
; breq    Label159
; rjmp    Label162

; Referenced from offset 0x792 by breq
; Label159:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 4          ; 0x10 = 16
; brtc    Label160
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x7a0 by brtc
; Label160:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label161
; rjmp    Label162

; Referenced from offset 0x7a8 by breq
; Label161:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x794 by rjmp
; Referenced from offset 0x7aa by rjmp
; Label162:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x09       ; 9
; breq    Label163
; rjmp    Label166

; Referenced from offset 0x7bc by breq
; Label163:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 5          ; 0x20 = 32
; brtc    Label164
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x7ca by brtc
; Label164:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label165
; rjmp    Label166

; Referenced from offset 0x7d2 by breq
; Label165:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x7be by rjmp
; Referenced from offset 0x7d4 by rjmp
; Label166:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0a       ; 10
; breq    Label167
; rjmp    Label170

; Referenced from offset 0x7e6 by breq
; Label167:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 6          ; 0x40 = 64
; brtc    Label168
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x7f4 by brtc
; Label168:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label169
; rjmp    Label170

; Referenced from offset 0x7fc by breq
; Label169:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x7e8 by rjmp
; Referenced from offset 0x7fe by rjmp
; Label170:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0b       ; 11
; breq    Label171
; rjmp    Label174

; Referenced from offset 0x810 by breq
; Label171:
; clr     r16
; ldi     r26, 0x39       ; 57
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 7          ; 0x80 = 128
; brtc    Label172
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x81e by brtc
; Label172:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label173
; rjmp    Label174

; Referenced from offset 0x826 by breq
; Label173:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x812 by rjmp
; Referenced from offset 0x828 by rjmp
; Label174:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0c       ; 12
; breq    Label175
; rjmp    Label178

; Referenced from offset 0x83a by breq
; Label175:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 0          ; 0x01 = 1
; brtc    Label176
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x848 by brtc
; Label176:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label177
; rjmp    Label178

; Referenced from offset 0x850 by breq
; Label177:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x83c by rjmp
; Referenced from offset 0x852 by rjmp
; Label178:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0d       ; 13
; breq    Label179
; rjmp    Label182

; Referenced from offset 0x864 by breq
; Label179:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label180
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x872 by brtc
; Label180:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label181
; rjmp    Label182

; Referenced from offset 0x87a by breq
; Label181:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x866 by rjmp
; Referenced from offset 0x87c by rjmp
; Label182:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0e       ; 14
; breq    Label183
; rjmp    Label186

; Referenced from offset 0x88e by breq
; Label183:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 0          ; 0x01 = 1
; brtc    Label184
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x89c by brtc
; Label184:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label185
; rjmp    Label186

; Referenced from offset 0x8a4 by breq
; Label185:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x890 by rjmp
; Referenced from offset 0x8a6 by rjmp
; Label186:
; lds     0x0062, r16     ; dat
; cpi     r16, 0x0f       ; 15
; breq    Label187
; rjmp    Label190

; Referenced from offset 0x8b8 by breq
; Label187:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label188
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x8c6 by brtc
; Label188:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label189
; rjmp    Label190

; Referenced from offset 0x8ce by breq
; Label189:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24

; Referenced from offset 0x678 by rjmp
; Referenced from offset 0x8ba by rjmp
; Referenced from offset 0x8d0 by rjmp
; Label190:
; lds     0x0063, r16     ; kom
; cpi     r16, 0x0d       ; 13
; breq    Label191
; rjmp    Label192

ausf_tb13:
cpi     Kom, 13          ; Befehl "13" Call
brne    ausf_tb14

mov     r24, XL
rcall   mypush
rjmp    ausf_jump

; Referenced from offset 0x8e2 by breq
; Label191:
; lds     0x0060, r24
; sts     0x0066, r24
; lds     0x0064, r16     ; adrHi
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds     0x0060, r16
; lds     0x0062, r20     ; dat
; add     r16, r20
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; st      X, r16

; Referenced from offset 0x8e4 by rjmp
; Label192:
; lds     0x0063, r16     ; kom
; cpi     r16, 0x0e       ; 14
; breq    Label193
; rjmp    Label194

ausf_tb14:
cpi     Kom, 14          ; Befehl "14" return
brne    ausf_tb15

rcall   mypop
mov     Dat, r24
rjmp    ausf_jump

; Referenced from offset 0x912 by breq
; Label193:
; lds     0x0066, r24
; sts     0x0060, r24

; Referenced from offset 0x914 by rjmp
; Label194:
; rjmp    Label6
ausf_tb15:
rjmp    ausf_loop

ausf_stackerr:
ldi     r16, 7
rjmp    ausf_err

mypush:
ld16    [r19:r18, SP + soSP - 1]
sub     r18, YL
sbc     r19, YH
brlo    ausf_stackerr
st      Y+, r24
ret

mypop:
ld16    [r19:r18, SP]
sub     r18, YL
sbc     r19, YH
brsh    ausf_stackerr
ld      r24, -Y
ret

; Referenced from offset 0xae by rjmp
; Referenced from offset 0xb0 by rjmp
programmieren:

 ; ldi     r16, 0xfa
 ; out     PORTA, r16
 ; ldi     r16, 10
 ; out     OCR0A, r16
 ; ld16    [r25:r24, 500]
 ; rcall   wait_ms
 ; ldi     r16, 0xf5
 ; out     PORTA, r16
 ; ldi     r16, 200
 ; out     OCR0A, r16
 ; ld16    [r25:r24, 500]
 ; rcall   wait_ms
 ; rjmp    programmieren

rcall   wait_key_released
ld16    [XH:XL, 0]
out     STSR, const_0

prog_loop:
mov     r16, XL         ; Adresse anzeigen
swap    r16
ori     r16, 0xf0
out     PORTA, r16      ; oberes Nibble
ld16    [r25:r24, 400]
rcall   wait_ms
mov     r16, XL
ori     r16, 0xf0
out     PORTA, r16      ; unteres Nibble
ld16    [r25:r24, 400]
rcall   wait_ms
ldi     r16, 0xf0
ld16    [r25:r24, 200]
rcall   wait_ms
rcall   EEPROM_read
mov     r17, r16
swap    r16
andi    Kom, 0xf        ; Befehl
andi    Dat, 0xf        ; Daten
mov     r24, Kom        ; Befehl

prog_loop0:
ori     r24, 0xf0
out     PORTA, r24      ; anzeigen

rcall   wait_key_pressed
sbrc    r24, S2
rjmp    prog_S1

sbis    STSR, SCHI       ; Taste 2
rjmp    prog_S2_start
cbi     STSR, SCHI
sbis    STSR, SDAT
rjmp    prog_S2_Kom
mov     Dat, r18
rjmp    prog_S2_start

prog_S2_Kom:
mov     Kom, r18

prog_S2_start:
sbic    STSR, SDAT
rjmp    prog_S2_next
sbi     STSR, SDAT
mov     r24, Dat
rjmp    prog_loop0

prog_S2_next:
sbis    STSR, SCHG
rjmp    prog_S2_nAd
swap    r16
andi    r16, 0xf0
andi    r17, 0xf
add     r16, r17
rcall   EEPROM_write

prog_S2_nAd:
out     STSR, const_0
adiw    XL, 1
ld16    [r17:r16, EEPROMEND - 4]
sub     r16, XL
sbc     r17, XH
brsh    prog_loop
rjmp    ausf_pcerr

prog_S1:
sbi     STSR, SCHG
sbic    STSR, SCHI
rjmp    prog_S1_go
sbi     STSR, SCHI
ldi     r18, -1
prog_S1_go:
inc     r18
mov     r24, r18
rjmp    prog_loop0

; Label195:
; ldi     r24, 0x00       ; 0
; sts     0x0060, r24
; ldi     r24, 0x00       ; 0
; sts     0x0067, r24

; Referenced from offset 0xbec by rjmp
; Label196:
; lds     0x0060, r16
; ldi     r20, 0x0f       ; 15
; and     r16, r20
; ldi     r26, 0x65       ; 101
; ldi     r27, 0x00       ; 0
; st      X, r16
; lds     0x0065, r16
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27
; ldi     r24, 0x2c       ; 44
; ldi     r25, 0x01       ; 1
; rcall   wait_ms
; ldi     r24, 0xf0       ; 240
; out     0x1b, r24       ; 27
; ldi     r24, 0xc8       ; 200
; ldi     r25, 0x00       ; 0
; rcall   wait_ms
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r30, X
; clr     r31
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; ldi     r25, 0x01       ; 1
; rcall   Function14
; lds     0x0061, r16
; ldi     r20, 0x0f       ; 15
; and     r16, r20
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; st      X, r16
; lds     0x0061, r16
; ldi     r20, 0x10       ; 16
; rcall   Function16
; ldi     r26, 0x63       ; 99
; ldi     r27, 0x00       ; 0
; st      X, r16
; lds     0x0063, r16     ; kom
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27

; Referenced from offset 0x99e by rjmp
; Label197:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label198
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x994 by brtc
; Label198:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label199
; rjmp    Label197

; Referenced from offset 0x99c by breq
; Label199:
; ldi     r24, 0x28       ; 40
; ldi     r25, 0x00       ; 0
; rcall   wait_ms
; ldi     r24, 0x01       ; 1
; sts     0x0067, r24

; Referenced from offset 0xbea by rjmp
; Label200:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 0          ; 0x01 = 1
; brtc    Label201
; ldi     r16, 0x01       ; 1

; Referenced from offset 0x9b6 by brtc
; Label201:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label202
; rjmp    Label216

; Referenced from offset 0x9be by breq
; Label202:
; lds     0x0067, r16
; cpi     r16, 0x01       ; 1
; breq    Label203
; rjmp    Label204

; Referenced from offset 0x9c8 by breq
; Label203:
; ldi     r24, 0x02       ; 2
; sts     0x0067, r24
; ldi     r24, 0x0f       ; 15
; sts     0x0063, r24     ; kom

; Referenced from offset 0x9ca by rjmp
; Label204:
; lds     0x0067, r16
; cpi     r16, 0x02       ; 2
; breq    Label205
; rjmp    Label206

; Referenced from offset 0x9de by breq
; Label205:
; ldi     r26, 0x63       ; 99
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r26, 0x63       ; 99
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds     0x0063, r16     ; kom
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27

; Referenced from offset 0x9e0 by rjmp
; Label206:
; lds     0x0067, r16
; cpi     r16, 0x03       ; 3
; breq    Label207
; rjmp    Label208

; Referenced from offset 0xa06 by breq
; Label207:
; ldi     r24, 0x05       ; 5
; sts     0x0067, r24
; ldi     r24, 0x0f       ; 15
; sts     0x0062, r24     ; dat

; Referenced from offset 0xa08 by rjmp
; Label208:
; lds     0x0067, r16
; cpi     r16, 0x04       ; 4
; breq    Label209
; rjmp    Label210

; Referenced from offset 0xa1c by breq
; Label209:
; ldi     r24, 0x05       ; 5
; sts     0x0067, r24
; ldi     r24, 0x0f       ; 15
; sts     0x0062, r24     ; dat

; Referenced from offset 0xa1e by rjmp
; Label210:
; lds     0x0067, r16
; cpi     r16, 0x05       ; 5
; breq    Label211
; rjmp    Label212

; Referenced from offset 0xa32 by breq
; Label211:
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds     0x0062, r16     ; dat
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27

; Referenced from offset 0xa34 by rjmp
; Label212:
; ldi     r24, 0x28       ; 40
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0xa6e by rjmp
; Label213:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 0          ; 0x01 = 1
; brtc    Label214
; ldi     r16, 0x01       ; 1

; Referenced from offset 0xa64 by brtc
; Label214:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label215
; rjmp    Label213

; Referenced from offset 0xa6c by breq
; Label215:
; ldi     r24, 0x28       ; 40
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0x9c0 by rjmp
; Label216:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label217
; ldi     r16, 0x01       ; 1

; Referenced from offset 0xa80 by brtc
; Label217:
; ldi     r20, 0x00       ; 0
; cp      r16, r20
; breq    Label218
; rjmp    Label236

; Referenced from offset 0xa88 by breq
; Label218:
; lds     0x0067, r16
; cpi     r16, 0x03       ; 3
; breq    Label219
; rjmp    Label220

; Referenced from offset 0xa92 by breq
; Label219:
; ldi     r24, 0x07       ; 7
; sts     0x0067, r24

; Referenced from offset 0xa94 by rjmp
; Label220:
; lds     0x0067, r16
; cpi     r16, 0x01       ; 1
; breq    Label221
; rjmp    Label222

; Referenced from offset 0xaa2 by breq
; Label221:
; lds     0x0062, r16     ; dat
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27
; ldi     r24, 0x03       ; 3
; sts     0x0067, r24

; Referenced from offset 0xaa4 by rjmp
; Label222:
; lds     0x0067, r16
; cpi     r16, 0x04       ; 4
; breq    Label223
; rjmp    Label224

; Referenced from offset 0xabc by breq
; Label223:
; ser     r16
; lds     0x0062, r20     ; dat
; sub     r16, r20
; out     0x1b, r16       ; 27
; ldi     r24, 0x06       ; 6
; sts     0x0067, r24

; Referenced from offset 0xabe by rjmp
; Label224:
; lds     0x0067, r16
; cpi     r16, 0x02       ; 2
; breq    Label225
; rjmp    Label226

; Referenced from offset 0xad6 by breq
; Label225:
; lds     0x0062, r16     ; dat
; ldi     r20, 0xf0       ; 240
; or      r16, r20
; out     0x1b, r16       ; 27
; ldi     r24, 0x04       ; 4
; sts     0x0067, r24

; Referenced from offset 0xad8 by rjmp
; Label226:
; lds     0x0067, r16
; cpi     r16, 0x06       ; 6
; breq    Label227
; rjmp    Label228

; Referenced from offset 0xaf0 by breq
; Label227:
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds     0x0063, r16     ; kom
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds     0x0061, r16
; lds     0x0062, r20     ; dat
; add     r16, r20
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; st      X, r16
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r30, X
; clr     r31
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; ldi     r25, 0x01       ; 1
; ldi     r23, 0x7b       ; 123
; rcall   Function13
; ser     r24
; out     0x1b, r24       ; 27
; ldi     r24, 0xf4       ; 244
; ldi     r25, 0x01       ; 1
; rcall   wait_ms
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r24, 0x00       ; 0
; sts     0x0067, r24

; Referenced from offset 0xaf2 by rjmp
; Label228:
; lds     0x0067, r16
; cpi     r16, 0x05       ; 5
; breq    Label229
; rjmp    Label230

; Referenced from offset 0xb4e by breq
; Label229:
; ldi     r26, 0x62       ; 98
; ldi     r27, 0x00       ; 0
; ld      r24, X
; cbr     r24, 0xf0       ; 240
; st      X, r24
; lds     0x0063, r16     ; kom
; ldi     r20, 0x10       ; 16
; rcall   Function15
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; st      X, r20
; lds     0x0061, r16
; lds     0x0062, r20     ; dat
; add     r16, r20
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; st      X, r16
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r30, X
; clr     r31
; ldi     r26, 0x61       ; 97
; ldi     r27, 0x00       ; 0
; ldi     r25, 0x01       ; 1
; ldi     r23, 0x7b       ; 123
; rcall   Function13
; ldi     r24, 0xf0       ; 240
; out     0x1b, r24       ; 27
; ldi     r24, 0xf4       ; 244
; ldi     r25, 0x01       ; 1
; rcall   wait_ms
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r24, 0x00       ; 0
; sts     0x0067, r24

; Referenced from offset 0xb50 by rjmp
; Label230:
; lds     0x0067, r16
; cpi     r16, 0x07       ; 7
; breq    Label231
; rjmp    Label232

; Referenced from offset 0xbac by breq
; Label231:
; ldi     r26, 0x60       ; 96
; ldi     r27, 0x00       ; 0
; ld      r24, X
; subi    r24, 0xff       ; 255
; st      X, r24
; ldi     r24, 0x00       ; 0
; sts     0x0067, r24

; Referenced from offset 0xbae by rjmp
; Label232:
; ldi     r24, 0x28       ; 40
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0xbda by rjmp
; Label233:
; clr     r16
; ldi     r26, 0x36       ; 54
; ldi     r27, 0x00       ; 0
; ld      r24, X
; bst     r24, 1          ; 0x02 = 2
; brtc    Label234
; ldi     r16, 0x01       ; 1

; Referenced from offset 0xbd0 by brtc
; Label234:
; ldi     r20, 0x01       ; 1
; cp      r16, r20
; breq    Label235
; rjmp    Label233

; Referenced from offset 0xbd8 by breq
; Label235:
; ldi     r24, 0x28       ; 40
; ldi     r25, 0x00       ; 0
; rcall   wait_ms

; Referenced from offset 0xa8a by rjmp
; Label236:
; lds     0x0067, r16
; cpi     r16, 0x00       ; 0
; breq    Label237
; rjmp    Label200

; Referenced from offset 0xbe8 by breq
; Label237:
; rjmp    Label196
; cli

; Referenced from offset 0xbf0 by rjmp
; Label238:
; rjmp    Label238
; mov     r30, r26
; mov     r31, r27

; Referenced from offset 0x358 by rcall
; Referenced from offset 0xbfe by brne
; Function1:
; ld      r24, X+
; com     r24
; st      Z+, r24
; dec     r20
; brne    Function1
; ret

; rcall   Function2
; rcall   Function8

; Referenced from offset 0xc12 by rjmp
; Label239:
; sbrc    r0, 0           ; 0x01 = 1
; rcall   Function3
; ret

; rcall   Function2
; rcall   Function7
; bld     r0, 1           ; 0x02 = 2
; rjmp    Label239

; Referenced from offset 0xc02 by rcall
; Referenced from offset 0xc0c by rcall
; Function2:
; clr     r0
; clt
; sbrs    r21, 7          ; 0x80 = 128
; rjmp    Label240
; rcall   Function4
; set

; Referenced from offset 0xc1a by rjmp
; Label240:
; bld     r0, 0           ; 0x01 = 1
; rcall   Function5
; bld     r1, 0           ; 0x01 = 1
; eor     r0, r1
; ret


; Referenced from offset 0xc08 by rcall
; Function3:
; rcall   Function4
; rcall   Function6
; ret


; Referenced from offset 0xc1c by rcall
; Referenced from offset 0xc2a by rcall
; Function4:
; com     r21
; com     r20
; subi    r20, 0xff       ; 255
; sbci    r21, 0xff       ; 255
; ret


; Referenced from offset 0xc22 by rcall
; Function5:
; clt
; sbrs    r17, 7          ; 0x80 = 128
; ret


; Referenced from offset 0xc2c by rcall
; Function6:
; com     r16
; com     r17
; subi    r16, 0xff       ; 255
; sbci    r17, 0xff       ; 255
; set
; ret


; Referenced from offset 0x450 by rcall
; Referenced from offset 0x48a by rcall
; Referenced from offset 0xc0e by rcall
; Function7:
; mov     r19, r21
; mov     r18, r20
; clt
; or      r20, r21
; brne    Label241
; set
; ret


; Referenced from offset 0xc54 by brne
; Label241:
; mov     r21, r17
; mov     r20, r16
; clr     r16
; clr     r17
; ldi     r24, 0x10       ; 16

; Referenced from offset 0xc7c by brne
; Label242:
; lsl     r20
; rol     r21
; rol     r16
; rol     r17
; sub     r16, r18
; sbc     r17, r19
; ori     r20, 0x01       ; 1
; brcc    Label243
; add     r16, r18
; adc     r17, r19
; cbr     r20, 0x01       ; 1

; Referenced from offset 0xc72 by brcc
; Label243:
; dec     r24
; brne    Label242
; ret


; Referenced from offset 0x344 by rcall
; Referenced from offset 0xc04 by rcall
; Function8:
; mov     r23, r21
; mov     r22, r20
; clr     r21
; clr     r20
; push    r31
; ldi     r31, 0x11       ; 17
; clc
; rjmp    Label246

; Referenced from offset 0xca0 by brne
; Label244:
; brcc    Label245
; add     r20, r22
; adc     r21, r23

; Referenced from offset 0xc90 by brcc
; Label245:
; lsr     r21
; ror     r20

; Referenced from offset 0xc8e by rjmp
; Label246:
; ror     r17
; ror     r16
; dec     r31
; brne    Label244
; pop     r31
; ret


; Referenced from offset 0xca8 by brne
; Label247:
; sbiw    r31:30, 0x01    ; 1
; brne    Label247
; ret

; set
; bld     r6, 2           ; 0x04 = 4
; ret

; clt
; bld     r6, 2           ; 0x04 = 4
; ret


; Referenced from offset 0x96 by rcall
; Referenced from offset 0x11a by rcall
; Referenced from offset 0x12a by rcall
; Referenced from offset 0x13a by rcall
; Referenced from offset 0x14a by rcall
; Referenced from offset 0x15a by rcall
; Referenced from offset 0x16a by rcall
; Referenced from offset 0x17a by rcall
; Referenced from offset 0x18a by rcall
; Referenced from offset 0x19a by rcall
; Referenced from offset 0x1aa by rcall
; Referenced from offset 0x1ba by rcall
; Referenced from offset 0x1ca by rcall
; Referenced from offset 0x1da by rcall
; Referenced from offset 0x1ea by rcall
; Referenced from offset 0x1fa by rcall
; Referenced from offset 0x20a by rcall
; Referenced from offset 0x948 by rcall
; Referenced from offset 0x952 by rcall
; Referenced from offset 0x9a4 by rcall
; Referenced from offset 0xa58 by rcall
; Referenced from offset 0xa74 by rcall
; Referenced from offset 0xb36 by rcall
; Referenced from offset 0xb94 by rcall
; Referenced from offset 0xbc4 by rcall
; Referenced from offset 0xbe0 by rcall
wait_ms:
push16  [ZH:ZL]
; push    r31
clr     r30
or      r30, r24
or      r30, r25
breq    wait_ms_ret

; Referenced from offset 0xcce by brne
wait_ms_next:
ld16    [ZH:ZL, CPUF / 1000 / 4]
; ldi     r30, 0xd0       ; 208
; ldi     r31, 0x07       ; 7

; Referenced from offset 0xcca by brne
wait_ms_loop:
 ; in      r16, PORTA
 ; mov     r16, ZH
 ; swap    r16
 ; ori     r16, 0xf0
 ; eor     r16, const_1
 ; out     PORTA, r16
sbiw    ZL, 1
brne    wait_ms_loop
sbiw    r24, 1
brne    wait_ms_next

; Referenced from offset 0xcc2 by breq
wait_ms_ret:
; pop     r31
pop16  [ZH:ZL]
ret

EEPROM_read:
; Wait for completion of previous write
sbic EECR, EEPE
rjmp EEPROM_read
; Set up address (r18:r17) in address registers
out EEARH, XH
out EEARL, XL
; Start eeprom read by writing EERE
sbi EECR, EERE
; Read data from data register
in r16, EEDR
ret

EEPROM_write:
push r24
; Wait for completion of previous write
sbic EECR, EEPE
rjmp EEPROM_write
; Set Programming mode
ldi r24, (0<<EEPM1)|(0<<EEPM0)
out EECR, r24
; Set up address (r18:r17) in address registers
out EEARH, XH
out EEARL, XL
; Write data (r19) to data register
out EEDR, r16
; Write logical one to EEMPE
sbi EECR, EEMPE
; Start eeprom write by setting EEPE
sbi EECR, EEPE
pop r24
ret


; Referenced from offset 0x43a by rcall
; Referenced from offset 0x474 by rcall
; Function10:
; sbi     ADCSR, 6        ; 0x40 = 64

; Referenced from offset 0xcda by rjmp
; Label251:
; sbic    ADCSR, 6        ; 0x40 = 64
; rjmp    Label251
; sbi     ADCSR, 6        ; 0x40 = 64

; Referenced from offset 0xce0 by rjmp
; Label252:
; sbic    ADCSR, 6        ; 0x40 = 64
; rjmp    Label252
; in      r24, ADCL
; in      r25, ADCH
; ret


; Referenced from offset 0x3b6 by rcall
; Function11:
; cpi     r25, 0x00       ; 0
; breq    Label254
; ld      r24, X

; Referenced from offset 0xcf2 by brne
; Label253:
; lsr     r24
; dec     r25
; brne    Label253
; st      X, r24

; Referenced from offset 0xcea by breq
; Label254:
; ret


; Referenced from offset 0xcfa by rjmp
; Referenced from offset 0xd10 by rcall
; Referenced from offset 0xd2a by rcall
; Function12:
; sbic    EECR, 1         ; 0x02 = 2
; rjmp    Function12
; out     EEAR, r30
; adiw    r31:30, 0x01    ; 1
; ret

; ldi     r25, 0x01       ; 1
; rjmp    Function13
; ldi     r25, 0x02       ; 2

; Referenced from offset 0xb2c by rcall
; Referenced from offset 0xb8a by rcall
; Referenced from offset 0xd04 by rjmp
; Function13:
; cpi     r23, 0x7b       ; 123
; brne    Label256
; in      r23, SREG
; cli

; Referenced from offset 0xd1c by brne
; Label255:
; rcall   Function12
; ld      r24, X+
; out     EEDR, r24
; sbi     EECR, 2         ; 0x04 = 4
; sbi     EECR, 1         ; 0x02 = 2
; dec     r25
; brne    Label255
; out     SREG, r23

; Referenced from offset 0xd0a by brne
; Label256:
; clr     r23
; ret

; ldi     r25, 0x01       ; 1
; rjmp    Function14
; ldi     r25, 0x02       ; 2

; Referenced from offset 0xc6 by rcall
; Referenced from offset 0x962 by rcall
; Referenced from offset 0xd26 by rjmp
; Referenced from offset 0xd34 by brne
; Function14:
; rcall   Function12
; sbi     EECR, 0         ; 0x01 = 1
; in      r24, EEDR
; st      X+, r24
; dec     r25
; brne    Function14
; ret


; Referenced from offset 0x514 by rcall
; Referenced from offset 0x5c4 by rcall
; Referenced from offset 0x60e by rcall
; Referenced from offset 0x658 by rcall
; Referenced from offset 0x8f4 by rcall
; Referenced from offset 0xb04 by rcall
; Referenced from offset 0xb62 by rcall
; Function15:
; push    r31
; clr     r21
; ldi     r31, 0x08       ; 8
; lsr     r20

; Referenced from offset 0xd4a by brne
; Label257:
; brcc    Label258
; add     r21, r16

; Referenced from offset 0xd40 by brcc
; Label258:
; ror     r21
; ror     r20
; dec     r31
; brne    Label257
; pop     r31
; ret


; Referenced from offset 0xe6 by rcall
; Referenced from offset 0x52e by rcall
; Referenced from offset 0x978 by rcall
; Function16:
; push    r31
; sub     r24, r24
; ldi     r31, 0x09       ; 9

; Referenced from offset 0xd6a by rjmp
; Referenced from offset 0xd6e by rjmp
; Label259:
; rol     r16
; dec     r31
; brne    Label260
; pop     r31
; ret


; Referenced from offset 0xd5a by brne
; Label260:
; rol     r24
; sub     r24, r20
; brcc    Label261
; add     r24, r20
; clc
; rjmp    Label259

; Referenced from offset 0xd64 by brcc
; Label261:
; sec
; rjmp    Label259

wait_key_pressed:
push16  [r19:r18]
push    r25

wait_key_pressed0:
rcall   get_keystat
breq    wait_key_pressed0
ld16    [r25:r24, 40]
rcall   wait_ms
rcall   get_keystat
breq    wait_key_pressed0
rjmp    wait_key_released0

wait_key_released:
push16  [r19:r18]
push    r25

wait_key_released0:
mov     r19, r18
rcall   get_keystat
brne    wait_key_released0
ld16    [r25:r24, 40]
rcall   wait_ms
rcall   get_keystat
brne    wait_key_released0
mov     r24, r19
pop     r25
pop16   [r19:r18]
ret

get_keystat:
 ; sbi     PORTB, S1
 ; sbi     PORTB, S2
in      r18, TAST
andi    r18, 1<<S1 | 1<<S2
cpi     r18, 1<<S1 | 1<<S2
ret


.dseg

AddrHi:   .byte 1
SP:       .byte soSP

.eseg

; .db 0x19, 0x29, 0x16, 0x29, 0x34
; .db 0x45, 0x54, 0x59, 0x29, 0x1a, 0x4a, 0x59, 0x29, 0x38
; .db 0x69, 0x54, 0x59, 0x29, 0x40, 0x59, 0x64, 0x54, 0x29, 0x39
; .db 0x69, 0x54, 0x28, 0x51, 0x42, 0x54, 0x28, 0x75, 0x54, 0x29, 0x3a
; .db 0x69, 0x54, 0x28, 0x52, 0x43, 0x54, 0x28, 0x51, 0x62, 0x76, 0x54, 0x29, 0x3c
.db 0x72, 0x54, 0x59, 0x27, 0x34
; .db 0x43, 0x54, 0x28, 0x51, 0x42, 0x54, 0x28, 0xc2, 0x11, 0x29, 0x80, 0x90
; .db 0x71, 0x54, 0x28, 0x1f, 0x28, 0xc7, 0x57, 0x2a, 0x80, 0x90
; .db 0x80, 0x40, 0x54, 0x29, 0x71, 0xd2
; .db 0x80, 0x96, 0x79, 0x54, 0x29, 0xe0, 0x43, 0x53, 0x51, 0xd2, 0xb9, 0xe0, 0x11, 0x30

; .org 0x7a
; .db 0x15, 0x13
